zenilib: zenilib/jni/external/freetype2/src/autofit/aflatin.h File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Classes | Macros | Typedefs | Enumerations | Functions
aflatin.h File Reference
`#include "afhints.h"`

Go to the source code of this file.

## Classes

struct | AF_LatinAxisRec_
struct | AF_LatinBlueRec_
struct | AF_LatinMetricsRec_

## Macros

#define | AF_LATIN_CONSTANT(metrics, c) ( ( (c) * (FT_Long)( (AF_LatinMetrics)(metrics) )->units_per_em ) / 2048 )
#define | AF_LATIN_HINTS_DO_HORZ_SNAP(h) AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_HORZ_SNAP )
#define | AF_LATIN_HINTS_DO_MONO(h) AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_MONO )
#define | AF_LATIN_HINTS_DO_STEM_ADJUST(h) AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_STEM_ADJUST )
#define | AF_LATIN_HINTS_DO_VERT_SNAP(h) AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_VERT_SNAP )
#define | AF_LATIN_IS_TOP_BLUE(b)
#define | AF_LATIN_MAX_BLUES AF_LATIN_BLUE_MAX
#define | AF_LATIN_MAX_WIDTHS 16

## Typedefs

typedef struct AF_LatinAxisRec_ * | AF_LatinAxis
typedef struct AF_LatinAxisRec_ | AF_LatinAxisRec
typedef struct AF_LatinBlueRec_ * | AF_LatinBlue
typedef struct AF_LatinBlueRec_ | AF_LatinBlueRec
typedef struct AF_LatinMetricsRec_ * | AF_LatinMetrics
typedef struct AF_LatinMetricsRec_ | AF_LatinMetricsRec

## Enumerations

enum | { AF_LATIN_BLUE_CAPITAL_TOP, AF_LATIN_BLUE_CAPITAL_BOTTOM, AF_LATIN_BLUE_SMALL_F_TOP, AF_LATIN_BLUE_SMALL_TOP, AF_LATIN_BLUE_SMALL_BOTTOM, AF_LATIN_BLUE_SMALL_MINOR, AF_LATIN_BLUE_MAX }
enum | { AF_LATIN_BLUE_ACTIVE = 1 << 0, AF_LATIN_BLUE_TOP = 1 << 1, AF_LATIN_BLUE_ADJUSTMENT = 1 << 2, AF_LATIN_BLUE_FLAG_MAX }
enum | { AF_LATIN_HINTS_HORZ_SNAP = 1 << 0, AF_LATIN_HINTS_VERT_SNAP = 1 << 1, AF_LATIN_HINTS_STEM_ADJUST = 1 << 2, AF_LATIN_HINTS_MONO = 1 << 3 }

## Functions

| af_latin_hints_compute_edges (AF_GlyphHints hints, AF_Dimension dim)
| af_latin_hints_compute_segments (AF_GlyphHints hints, AF_Dimension dim)
| af_latin_hints_detect_features (AF_GlyphHints hints, AF_Dimension dim)
| af_latin_hints_link_segments (AF_GlyphHints hints, AF_Dimension dim)
| af_latin_metrics_check_digits (AF_LatinMetrics metrics, FT_Face face)
| af_latin_metrics_init (AF_LatinMetrics metrics, FT_Face face)
| af_latin_metrics_init_widths (AF_LatinMetrics metrics, FT_Face face, FT_ULong charcode)
| af_latin_metrics_scale (AF_LatinMetrics metrics, AF_Scaler scaler)

## Macro Definition Documentation

#define AF_LATIN_CONSTANT | ( |  | metrics,
|  |  | c
| ) |  | ( ( (c) * (FT_Long)( (AF_LatinMetrics)(metrics) )->units_per_em ) / 2048 )

Definition at line 34 of file aflatin.h.

Referenced by af_latin2_hints_link_segments(), af_latin2_metrics_init_widths(), af_latin_hints_link_segments(), and af_latin_metrics_init_widths().

#define AF_LATIN_HINTS_DO_HORZ_SNAP | ( |  | h | ) | AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_HORZ_SNAP )

Definition at line 163 of file aflatin.h.

Referenced by af_latin2_compute_stem_width(), and af_latin_compute_stem_width().

#define AF_LATIN_HINTS_DO_MONO | ( |  | h | ) | AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_MONO )

Definition at line 172 of file aflatin.h.

Referenced by af_latin2_compute_stem_width(), and af_latin_compute_stem_width().

#define AF_LATIN_HINTS_DO_STEM_ADJUST | ( |  | h | ) | AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_STEM_ADJUST )

Definition at line 169 of file aflatin.h.

Referenced by af_latin2_compute_stem_width(), and af_latin_compute_stem_width().

#define AF_LATIN_HINTS_DO_VERT_SNAP | ( |  | h | ) | AF_HINTS_TEST_OTHER( h, AF_LATIN_HINTS_VERT_SNAP )

Definition at line 166 of file aflatin.h.

Referenced by af_latin2_compute_stem_width(), and af_latin_compute_stem_width().

#define AF_LATIN_IS_TOP_BLUE | ( |  | b | ) |

Value:
( (b) == AF_LATIN_BLUE_CAPITAL_TOP || \
(b) == AF_LATIN_BLUE_SMALL_F_TOP || \
(b) == AF_LATIN_BLUE_SMALL_TOP )
AF_LATIN_BLUE_SMALL_TOP
Definition: aflatin.h:61
AF_LATIN_BLUE_CAPITAL_TOP
Definition: aflatin.h:58
b
GLdouble GLdouble GLdouble b
Definition: glew.h:8383
AF_LATIN_BLUE_SMALL_F_TOP
Definition: aflatin.h:60

Definition at line 69 of file aflatin.h.

Referenced by af_latin2_metrics_init_blues(), and af_latin_metrics_init_blues().

#define AF_LATIN_MAX_BLUES AF_LATIN_BLUE_MAX

Definition at line 74 of file aflatin.h.

#define AF_LATIN_MAX_WIDTHS 16

Definition at line 73 of file aflatin.h.

Referenced by af_latin2_metrics_init_widths(), and af_latin_metrics_init_widths().

## Typedef Documentation

typedef struct AF_LatinAxisRec_ * AF_LatinAxis

typedef struct AF_LatinAxisRec_ AF_LatinAxisRec

typedef struct AF_LatinBlueRec_ * AF_LatinBlue

typedef struct AF_LatinBlueRec_ AF_LatinBlueRec

typedef struct AF_LatinMetricsRec_ * AF_LatinMetrics

typedef struct AF_LatinMetricsRec_ AF_LatinMetricsRec

## Enumeration Type Documentation

anonymous enum

Enumerator
AF_LATIN_BLUE_CAPITAL_TOP |
AF_LATIN_BLUE_CAPITAL_BOTTOM |
AF_LATIN_BLUE_SMALL_F_TOP |
AF_LATIN_BLUE_SMALL_TOP |
AF_LATIN_BLUE_SMALL_BOTTOM |
AF_LATIN_BLUE_SMALL_MINOR |
AF_LATIN_BLUE_MAX |

Definition at line 56 of file aflatin.h.

anonymous enum

Enumerator
AF_LATIN_BLUE_ACTIVE |
AF_LATIN_BLUE_TOP |
AF_LATIN_BLUE_ADJUSTMENT |
AF_LATIN_BLUE_FLAG_MAX |

Definition at line 77 of file aflatin.h.

anonymous enum

Enumerator
AF_LATIN_HINTS_HORZ_SNAP |
AF_LATIN_HINTS_VERT_SNAP |
AF_LATIN_HINTS_STEM_ADJUST |
AF_LATIN_HINTS_MONO |

Definition at line 152 of file aflatin.h.

## Function Documentation

af_latin_hints_compute_edges | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 1039 of file aflatin.c.

References af_axis_hints_new_edge(), AF_DIMENSION_HORZ, AF_DIR_NONE, AF_DIR_RIGHT, AF_DIR_UP, AF_EDGE_NORMAL, AF_EDGE_ROUND, AF_EDGE_SERIF, AF_SegmentRec_::dir, AF_EdgeRec_::dir, AF_SegmentRec_::edge, AF_LatinAxisRec_::edge_distance_threshold, AF_SegmentRec_::edge_next, AF_AxisHintsRec_::edges, error, AF_EdgeRec_::first, AF_SegmentRec_::flags, AF_EdgeRec_::flags, AF_EdgeRec_::fpos, FT_Bool, FT_DivFix(), FT_MulFix(), FT_Pos, FT_ZERO, AF_SegmentRec_::height, AF_EdgeRec_::last, AF_SegmentRec_::link, AF_EdgeRec_::link, AF_SegmentRec_::max_coord, AF_SegmentRec_::min_coord, NULL, AF_AxisHintsRec_::num_edges, AF_AxisHintsRec_::num_segments, AF_EdgeRec_::opos, AF_SegmentRec_::pos, AF_EdgeRec_::pos, AF_AxisHintsRec_::segments, AF_SegmentRec_::serif, and AF_EdgeRec_::serif.

Referenced by af_latin_hints_detect_features().

af_latin_hints_compute_segments | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 726 of file aflatin.c.

References af_axis_hints_new_segment(), AF_DIMENSION_HORZ, AF_EDGE_NORMAL, AF_EDGE_ROUND, AF_FLAG_CONTROL, AF_SegmentRec_::dir, error, AF_SegmentRec_::first, AF_PointRec_::flags, AF_SegmentRec_::flags, FT_ABS, FT_Bool, FT_Pos, FT_ZERO, AF_PointRec_::fx, AF_PointRec_::fy, AF_SegmentRec_::height, if(), AF_SegmentRec_::last, AF_AxisHintsRec_::major_dir, AF_SegmentRec_::max_coord, AF_SegmentRec_::min_coord, AF_PointRec_::next, NULL, AF_AxisHintsRec_::num_segments, AF_PointRec_::out_dir, AF_SegmentRec_::pos, AF_PointRec_::prev, AF_SegmentRec_::score, AF_AxisHintsRec_::segments, u, AF_PointRec_::u, and AF_PointRec_::v.

Referenced by af_latin_hints_detect_features(), and af_latin_metrics_init_widths().

af_latin_hints_detect_features | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 1333 of file aflatin.c.

References af_latin_hints_compute_edges(), af_latin_hints_compute_segments(), af_latin_hints_link_segments(), and error.

Referenced by af_latin_hints_apply().

af_latin_hints_link_segments | ( | AF_GlyphHints | hints,
|  | AF_Dimension | dim
| ) |  |

Definition at line 946 of file aflatin.c.

References AF_LATIN_CONSTANT, AF_SegmentRec_::dir, AF_SegmentRec_::first, FT_Pos, AF_SegmentRec_::last, AF_SegmentRec_::link, AF_AxisHintsRec_::major_dir, max, AF_SegmentRec_::max_coord, min, AF_SegmentRec_::min_coord, AF_AxisHintsRec_::num_segments, AF_SegmentRec_::pos, AF_SegmentRec_::score, AF_AxisHintsRec_::segments, and AF_SegmentRec_::serif.

Referenced by af_latin_hints_detect_features(), and af_latin_metrics_init_widths().

af_latin_metrics_check_digits | ( | AF_LatinMetrics | metrics,
|  | FT_Face | face
| ) |  |

Definition at line 431 of file aflatin.c.

References FT_Bool, FT_Get_Advance(), FT_Get_Char_Index(), FT_LOAD_IGNORE_TRANSFORM, FT_LOAD_NO_HINTING, FT_LOAD_NO_SCALE, and i.

Referenced by af_latin_metrics_init().

af_latin_metrics_init | ( | AF_LatinMetrics | metrics,
|  | FT_Face | face
| ) |  |

Definition at line 478 of file aflatin.c.

References af_latin_metrics_check_digits(), af_latin_metrics_init_blues(), af_latin_metrics_init_widths(), error, FT_Select_Charmap(), and FT_Set_Charmap().

af_latin_metrics_init_widths | ( | AF_LatinMetrics | metrics,
|  | FT_Face | face,
|  | FT_ULong | charcode
| ) |  |

Definition at line 55 of file aflatin.c.

References AF_DIMENSION_HORZ, AF_DIMENSION_MAX, AF_DIMENSION_VERT, af_glyph_hints_done(), af_glyph_hints_init(), af_glyph_hints_reload(), af_glyph_hints_rescale(), AF_LATIN_CONSTANT, af_latin_hints_compute_segments(), af_latin_hints_link_segments(), AF_LATIN_MAX_WIDTHS, af_sort_widths(), AF_GlyphHintsRec_::axis, AF_LatinAxisRec_::edge_distance_threshold, error, AF_LatinAxisRec_::extra_light, AF_ScalerRec_::face, AF_ScalerRec_::flags, FT_Get_Char_Index(), FT_Load_Glyph(), FT_LOAD_NO_SCALE, FT_Pos, FT_RENDER_MODE_NORMAL, FT_ZERO, AF_SegmentRec_::link, AF_GlyphHintsRec_::memory, AF_AxisHintsRec_::num_segments, AF_SegmentRec_::pos, AF_ScalerRec_::render_mode, AF_LatinMetricsRec_::root, AF_ScriptMetricsRec_::scaler, AF_AxisHintsRec_::segments, AF_LatinAxisRec_::standard_width, AF_LatinMetricsRec_::units_per_em, AF_LatinAxisRec_::width_count, AF_LatinAxisRec_::widths, AF_ScalerRec_::x_delta, AF_ScalerRec_::x_scale, AF_ScalerRec_::y_delta, and AF_ScalerRec_::y_scale.

Referenced by af_latin_metrics_init().

af_latin_metrics_scale | ( | AF_LatinMetrics | metrics,
|  | AF_Scaler | scaler
| ) |  |

Definition at line 703 of file aflatin.c.

References AF_DIMENSION_HORZ, AF_DIMENSION_VERT, and af_latin_metrics_scale_dim().